﻿namespace FlaUI.Core.Definitions
{
    /// <summary>
    /// Types of controls in Microsoft UI Automation.
    /// </summary>
    public enum ControlType
    {

        /// <summary>
        /// Identifies an unknown control type.
        /// </summary>
        Unknown,

        /// <summary>
        /// Identifies the AppBar control type. Supported starting with Windows 8.1.
        /// </summary>
        AppBar,

        /// <summary>
        /// Identifies the Button control type.
        /// </summary>
        Button,

        /// <summary>
        /// Identifies the Calendar control type.
        /// </summary>
        Calendar,

        /// <summary>
        /// Identifies the CheckBox control type.
        /// </summary>
        CheckBox,

        /// <summary>
        /// Identifies the ComboBox control type.
        /// </summary>
        ComboBox,

        /// <summary>
        /// Identifies the Custom control type.
        /// </summary>
        Custom,

        /// <summary>
        /// Identifies the DataGrid control type.
        /// </summary>
        DataGrid,

        /// <summary>
        /// Identifies the DataItem control type.
        /// </summary>
        DataItem,

        /// <summary>
        /// Identifies the Document control type.
        /// </summary>
        Document,

        /// <summary>
        /// Identifies the Edit control type.
        /// </summary>
        Edit,

        /// <summary>
        /// Identifies the Group control type.
        /// </summary>
        Group,

        /// <summary>
        /// Identifies the Header control type.
        /// </summary>
        Header,

        /// <summary>
        /// Identifies the HeaderItem control type.
        /// </summary>
        HeaderItem,

        /// <summary>
        /// Identifies the Hyperlink control type.
        /// </summary>
        Hyperlink,

        /// <summary>
        /// Identifies the Image control type.
        /// </summary>
        Image,

        /// <summary>
        /// Identifies the List control type.
        /// </summary>
        List,

        /// <summary>
        /// Identifies the ListItem control type.
        /// </summary>
        ListItem,

        /// <summary>
        /// Identifies the MenuBar control type.
        /// </summary>
        MenuBar,

        /// <summary>
        /// Identifies the Menu control type.
        /// </summary>
        Menu,

        /// <summary>
        /// Identifies the MenuItem control type.
        /// </summary>
        MenuItem,

        /// <summary>
        /// Identifies the Pane control type.
        /// </summary>
        Pane,

        /// <summary>
        /// Identifies the ProgressBar control type.
        /// </summary>
        ProgressBar,

        /// <summary>
        /// Identifies the RadioButton control type.
        /// </summary>
        RadioButton,

        /// <summary>
        /// Identifies the ScrollBar control type.
        /// </summary>
        ScrollBar,

        /// <summary>
        /// Identifies the SemanticZoom control type. Supported starting with Windows 8.
        /// </summary>
        SemanticZoom,

        /// <summary>
        /// Identifies the Separator control type.
        /// </summary>
        Separator,

        /// <summary>
        /// Identifies the Slider control type.
        /// </summary>
        Slider,

        /// <summary>
        /// Identifies the Spinner control type.
        /// </summary>
        Spinner,

        /// <summary>
        /// Identifies the SplitButton control type.
        /// </summary>
        SplitButton,

        /// <summary>
        /// Identifies the StatusBar control type.
        /// </summary>
        StatusBar,

        /// <summary>
        /// Identifies the Tab control type.
        /// </summary>
        Tab,

        /// <summary>
        /// Identifies the TabItem control type.
        /// </summary>
        TabItem,

        /// <summary>
        /// Identifies the Table control type.
        /// </summary>
        Table,

        /// <summary>
        /// Identifies the Text control type.
        /// </summary>
        Text,

        /// <summary>
        /// Identifies the Thumb control type.
        /// </summary>
        Thumb,

        /// <summary>
        /// Identifies the TitleBar control type.
        /// </summary>
        TitleBar,

        /// <summary>
        /// Identifies the ToolBar control type.
        /// </summary>
        ToolBar,

        /// <summary>
        /// Identifies the ToolTip control type.
        /// </summary>
        ToolTip,

        /// <summary>
        /// Identifies the Tree control type.
        /// </summary>
        Tree,

        /// <summary>
        /// Identifies the TreeItem control type.
        /// </summary>
        TreeItem,

        /// <summary>
        /// Identifies the Window control type.
        /// </summary>
        Window
    }
}
